"""
Fuzzy C-Means Greylevel Segmentation
Eddie Ma - http://eddiema.ca - ed.yt.ma@gmail.com

This is something I put together for a course project.
See the below page for the accompanying blog post and project paper.

http://eddiema.ca/2011/12/20/fuzzy-c-means-for-greylevel-image-segmentation
"""

import sys
import png
import numpy
from util import *
from problem_space import *
from FCM import *

if len(sys.argv) != 3:
    exit("Usage: <image_name>.png <int segments>")

test_file = sys.argv[1]
test_data = read_png_to_matrix(test_file)

n_segments = int(sys.argv[2])

print >>sys.stderr, test_file, '@', len(test_data), 'x', len(test_data[0])

problem_space = create_problem_space(test_data)

print >>sys.stderr, test_file, '@ unique grey levels:', len(problem_space)

defuzz_dict, fuzzy_partition, fuzzy_centroids = FCM(
    problem_space, n_segments, statistics = True)
FCMImage = defuzzify_image(defuzz_dict, test_data)
matrix_save_png(
    FCMImage, test_file[:-4] + "_segmented" + str(n_segments) + ".png")

PC = PC_partition_fitness(fuzzy_partition)
PE = PE_partition_fitness(fuzzy_partition)
XB = XB_partition_fitness(problem_space, fuzzy_partition, fuzzy_centroids)
PBMF = PBMF_partition_fitness(problem_space, fuzzy_partition, fuzzy_centroids)

print >>sys.stderr, "PC (higher better): %0.3f" % PC
print >>sys.stderr, "PE (lower better): %0.3f" % PE
print >>sys.stderr, "XB (lower better): %0.3f" % XB
print >>sys.stderr, "PBMF (higher better): %0.3f" % PBMF
